export declare type EventType<Type extends string = string, Data extends object = {}> = {
    type: Type;
} & Data;
export declare type Dispatch<E extends EventType> = (data: Omit<E, 'type'>) => void;
export declare function useEvent<E extends EventType>(type: E['type'], onEvent?: (event: E) => void): Dispatch<E>;
export declare function dispatch<E extends EventType>(type: E['type'], data: Omit<E, 'type'>): void;
export default useEvent;
