"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dispatch = exports.useEvent = void 0;
var react_1 = require("react");
function useEvent(type, onEvent) {
    react_1.useEffect(function () {
        if (!onEvent)
            return;
        window.addEventListener(type, onEvent);
        return function () {
            window.removeEventListener(type, onEvent);
        };
    }, [type, onEvent]);
    var dispatchEvent = react_1.useCallback(function (data) {
        dispatch(type, data);
    }, [type]);
    return dispatchEvent;
}
exports.useEvent = useEvent;
function dispatch(type, data) {
    var event = Object.assign(new Event(type), data);
    window.dispatchEvent(event);
}
exports.dispatch = dispatch;
exports.default = useEvent;
//# sourceMappingURL=use-event.js.map